import java.io.*;
import java.util.*;

public class Main {

    public static void main(String[] args) throws IOException {
        int n = nextInt();
        int m = nextInt();
        char mas[][] = new char[n][6];
        int col = 0;
        for (int i = 0; i < n; i++) {
            String str = nextToken();
            for (int j = 0; j < 6; j++) {
                mas[i][j] = str.charAt(j);
                if (mas[i][j] == 'X') {
                    col++;
                }
            }
        }
        if ((col + m) % 2 != 0 || col + m > n * 6) {
            System.out.println("Impossible");
            return;
        }
        col=m;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < 6; j++) {
                if (mas[i][j] == 'X' && mas[i][5 - j] != 'X') {
                    if (col==0){
                        System.out.println("Impossible");
                        return;
                    }else{
                        col--;
                        mas[i][5-j]='X';
                    }
                }
            }
        }
        if (col!=0){
            for (int i = 0; i < n && col!=0; i++) {
                for (int j = 0; j < 6 && col!=0; j++) {
                    if (mas[i][j]=='.' && mas[i][5-j]=='.'){
                        mas[i][j]='X';
                        mas[i][5-j]='X';
                        col-=2;
                    }
                }
            }
        }
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < 6; j++) {
                System.out.print(mas[i][j]);
            }
            System.out.println();
        }
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter pw = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}