import java.io.*;
import java.util.*;

public class Main {

    public static void main(String[] args) throws IOException {
        int h = nextInt();
        int w = nextInt();
        int mas[][] = new int[h][w];
        long sum[] = new long[h];
        for (int i = 0; i < h; i++) {
            for (int j = 0; j < w; j++) {
                mas[i][j] = nextInt();
                sum[i] += mas[i][j];
            }
        }
        long k = nextLong();
        Deque<Integer> deq = new ArrayDeque<>();
        for (int i = h - 1; i >= 0; i--) {
            if (k - sum[i] >= 0) {
                k -= sum[i];
                deq.add(i + 1);
            }
        }
        if (k != 0) {
            System.out.println("NO");
        } else {
            System.out.println("YES");
            System.out.println(deq.size());
            for (;!deq.isEmpty();) {
                System.out.print(1 + " " + deq.pollFirst() + " ");
            }
        }
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter pw = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}