import java.io.*;
import java.util.*;

public class Main {

    public static void main(String[] args) throws IOException {
        int n = nextInt();
        int m = nextInt();
        int mas[] = new int[n];
        int arr[] = new int[n];
        for (int i = 0; i < mas.length; i++) {
            mas[i] = nextInt();
        }
        for (int i = 0; i < arr.length; i++) {
            arr[i] = nextInt();
        }
        long ans = 0;
        long begin = 0;
        long end = Long.MAX_VALUE;
        for (int i = 0; begin + 1 != end; i++) {
            ans = 0;
            long mid = (begin + end) / 2;
            for (int j = 0; j < n; j++) {
                if (mid >= mas[j] && mid < mas[j] + arr[j]) {
                    ans++;
                } else if (mid >= mas[j] + arr[j]) {
                    ans += Math.pow(2, mid - mas[j] - arr[j] + 1);
                }
            }
            if (ans > m || ans < 0) {
                end = mid;
            } else {
                begin = mid;
            }
        }
        if (ans!=m){
            System.out.println(-1);
            return;
        }
        System.out.println(begin);
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter pw = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}