import java.io.*;
import java.util.*;

public class Main {

    public static void main(String[] args) throws IOException {
        int n = nextInt();
        int m = nextInt();
        Long mas[][] = new Long[n][2];
        long max = Long.MAX_VALUE;
        long point = max;
        for (int i = 0; i < n; i++) {
            mas[i][0] = nextLong();
        }
        for (int i = 0; i < n; i++) {
            mas[i][1] = nextLong();
        }
        Arrays.sort(mas);
        for (int i = 0; i < mas.length; i++) {
            max = Math.min(max, mas[i][1] + mas[i][0]);
        }
        long ans = 0;
        long begin = 0;
        long end = Long.MAX_VALUE/1000000000;
        for (int i = 0; begin + 1 < end; i++) {
            if (begin >= end && ans != m) {
                System.out.println(-1);
                return;
            }else if (begin >= end){
                System.out.println((begin+end)/2);
                return;
            }
            ans = 0;
            boolean unfrozen = false;
            long mid = (begin + end) / 2;
            for (int j = 0; j < n; j++) {
                if (mid >= mas[j][0] && mid < mas[j][0] + mas[j][1]) {
                    ans++;
                } else if (mid >= mas[j][0] + mas[j][1]) {
                    unfrozen = true;
                    if (mid - mas[j][0] - mas[j][1] + 1 > 200) {
                        ans = m + 1;
                        break;
                    }
                    ans += Math.pow(2, mid - mas[j][0] - mas[j][1] + 1);
                }
            }
            if (ans == m && unfrozen) {
                break;
            } else if (ans == m && !unfrozen) {
                int l = 0;
                boolean was = false;
                for (int j = 0; j < mas.length; j++) {
                    if (mas[j][0] <= mid) {
                        l++;
                    } else {
                        begin = mas[j - 1][0];
                        end = mas[j - 1][0];
                        was = true;
                        break;
                    }
                }
                if (!was) {
                    begin = mas[mas.length - 1][0];
                    end = begin;
                    break;
                }
                break;
            }
            if (ans >= m || ans < 0) {
                end = mid;
            } else {
                begin = mid;
            }
        }
        if (ans != m) {
            System.out.println(-1);
            return;
        }
        System.out.println((begin + end) / 2);
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter pw = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}